gnutls_record_send_file(3)

NAME
gnutls_record_send_file - API function

SYNOPSIS
#include <gnutls/gnutls.h>

ssize_t gnutls_record_send_file(gnutls_session_t session, int fd, off_t * offset, size_t count);

ARGUMENTS

gnutls_session_t session
    is a gnutls_session_t type.

int fd
    file descriptor from which to read data.

off_t * offset
    Is relative to file offset, denotes the starting location for reading. after function returns, it point to position following last read byte.

size_t count
    is the length of the data in bytes to be read from file and send.

DESCRIPTION
This function sends data from fd . If KTLS (kernel TLS) is enabled, it will use the sendfile() system call to avoid overhead of copying data between user space and the kernel. Otherwise, this functionality is merely emulated by calling read() and gnutls_record_send(). If this implementation is suboptimal, check whether KTLS is enabled using gnutls_transport_is_ktls_enabled(). If offset is NULL then file offset is incremented by number of bytes send, otherwise file offset remains unchanged.

RETURNS
The number of bytes sent, or a negative error code.

REPORTING BUGS
Report bugs to <bugs@gnutls.org>.
Home page: https://www.gnutls.org

COPYRIGHT
Copyright © 2001- Free Software Foundation, Inc., and others.
Copying and distribution of this file, with or without modification, are permitted in any medium without royalty provided the copyright notice and this notice are preserved.

SEE ALSO
The full documentation for gnutls is maintained as a Texinfo manual. If the /usr/share/doc/gnutls/ directory does not contain the HTML form visit

https://www.gnutls.org/manual/